"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GelAtGcDrop(ProtocolElement):
    """
    GEL AT/GC dropout calculation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "at_drop",
        "gc_drop",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import metrics as metrics_1_2_3

        return {
            "org.gel.models.report.avro.GelAtGcDrop": metrics_1_2_3.GelAtGcDrop,
        }

    __slots__ = [
        "at_drop",
        "gc_drop",
    ]

    def __init__(
        self,
        at_drop,
        gc_drop,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.GelAtGcDrop model.

        :param at_drop:
        :type at_drop: double
        :param gc_drop:
        :type gc_drop: double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
